#include<iostream>
#include<vector>
#include<string>

#include<fstream>

typedef vector<vector<int> > Field;
int my_min = 1000;

bool fill_field(Field field,int my_min_act,int x,int y,int x1, int y1, int value)
{
	if (x == x1 && y == y1) {
		if (my_min < my_min_act)
			my_min_act = my_min; 
		return true;
	}
	
	if (x < 0 || y << 0 || x > 75 || y > 75)
		return false;

	if (field[y][x] == 1)
		return false;
	
	field[y][x] = value;

	fill_field(field, my_min_act + 1, x - 1, y, x1, y1, value);
	fill_field(field, my_min_act + 1,x + 1, y, x1, y1, value);
	fill_field(field, my_min_act + 1,x, y - 1, x1, y1, value);
	fill_field(field, my_min_act + 1,x, y + 1, x1, y1, value);	 
}

bool test_segment(Field field,int x1,int y1,int x2,int y2)
{
	return fill_field(field, 0,  x1, y1, x2, y2, 255);
}


int main()
{
	ifstream is("game.in");
	Field field;
	int bnum = 0;
	while (1) {
		int x, y;
		is >> x >> y;
		if (x==0 && y == 0)
			break;
		cout << x << " - " << y << endl;
		field.clear();
		{
			vector<int> tmp;
			tmp.resize(x + 2);
			field.push_back(tmp);
		}

		for (int b=0;b<y;b++) {
			vector<int> tmp;
			tmp.resize(x + 2);
			for (int a=0;a<x;a++) {
				char ch;
				is >> ch;
				if (ch == 'X')
					tmp[a + 1] = 1;
				else
					tmp[a + 1] = 0;
			}
			field.push_back(tmp);
		}

		{				
			vector<int> tmp;
			tmp.resize(x + 2);
			field.push_back(tmp);
		}
		
		cout << "Board #"<<++bnum << ":" << endl;		
		
		int n = 0;
		while (1) {
			int x1,y1;
			int x2,y2;
			is >> x1 >> y1;
			is >> x2 >> y2;
			if (x1 == 0 && y1 == 0 && x2 == 0 && y2 == 0)
				break;
			cout << "Pair " << ++n << ": ";
			if (!test_segment(field, x1 + 1,y1 + 1, x2 + 1,y2 + 1)) 
				cout << "impossible." << endl;
			else
				cout << my_min << " segments." << endl;
		}
	

	}
	

}
